Subject: bug#12314: 24.2.50; `add-to-history': use `setq' with `delete'

From: Eli Zaretskii <[email-masked]>
Date: Sun, 09 Sep 2012 20:25:56 +0300

> From: Chong Yidong <[email-masked]>
> Cc: Drew Adams <[email-masked]>,  [email-masked]
> Date: Sun, 09 Sep 2012 15:53:34 +0800
> 
> Eli Zaretskii <[email-masked]> writes:
> 
> > But the manual should cater first and foremost to newbies.  The rest
> > will get the point when they read the detailed description of how the
> > list is modified.
> 
> I modified the manual to hopefully make the situation clearer.  In
> particular, the descriptions of delq and delete explicitly say that you
> typically ought to use the return value.

Thanks, the text is much better now.  I still think the "destructive
modification" part should be retired to later in the description,
perhaps as notes, because it invokes mental models that get in the way
of interpreting the text correctly.  But I won't fight over it.

> The docstrings are harder, since they should be succinct.  Here is what
> I suggest; WDYT?
> 
> 
> (delq ELT LIST)
> 
> Delete by side effect occurrences of ELT as a member of LIST.
> Comparison is done with `eq'.  Return the resulting list.
> 
> More precisely, this function skips any occurrences of ELT at the
> front of LIST, then removes occurrences of ELT from the remaining
> sublist by modifying the list structure, then returns the resulting
> sublist.
> 
> Therefore, write `(setq foo (delq element foo))' to be sure of
> changing the value of `foo'.

I would remove the "by side effect" part, as it doesn't really add
anything of importance, and OTOH runs a real risk of confusing the
reader.  Otherwise, I think this is fine.  Thanks.

> (delete ELT SEQ)
> 
> Delete occurrence of ELT as a member of SEQ.
> SEQ must be a sequence (i.e. a list, a vector, or a string).
> Comparison is done with `equal'.  Return the resulting sequence.
> 
> If SEQ is a list, this behaves like `delq', except that it compares
> with `equal' instead of `eq'.  In particular, it may remove elements
> by altering the list structure.
> 
> If SEQ is not a list, deletion is not a side effect; this function
> creates and returns a new sequence.
> 
> Therefore, write `(setq foo (delete element foo))'
> to be sure of changing the value of `foo'.

This is also OK, except that I'd prefer an explicit description to a
reference to 'delq' in the second paragraph.  The corresponding text
in the doc string of 'delq' is short enough, so there are no real
savings in the reference, while the disadvantage of having to consult
another doc string is real.